<?php
/**
 * Wheel Alignment Service functions and definitions
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package wheel_alignment_service
 */

if ( ! defined( 'WHEEL_ALIGNMENT_SERVICE_VERSION' ) ) {
	define( 'WHEEL_ALIGNMENT_SERVICE_VERSION', '1.0.0' );
}
$wheel_alignment_service_theme_data = wp_get_theme();

if( ! defined( 'WHEEL_ALIGNMENT_SERVICE_THEME_VERSION' ) ) define ( 'WHEEL_ALIGNMENT_SERVICE_THEME_VERSION', $wheel_alignment_service_theme_data->get( 'Version' ) );
if( ! defined( 'WHEEL_ALIGNMENT_SERVICE_THEME_NAME' ) ) define( 'WHEEL_ALIGNMENT_SERVICE_THEME_NAME', $wheel_alignment_service_theme_data->get( 'Name' ) );

if ( ! function_exists( 'wheel_alignment_service_setup' ) ) :
	
	function wheel_alignment_service_setup() {
		
		load_theme_textdomain( 'wheel-alignment-service', get_template_directory() . '/languages' );

		add_theme_support( 'woocommerce' );

		add_theme_support( 'automatic-feed-links' );
		
		add_theme_support( 'title-tag' );

		add_theme_support( 'post-thumbnails' );

		register_nav_menus(
			array(
				'primary' => esc_html__( 'Primary', 'wheel-alignment-service' ),
			)
		);

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'style',
				'script',
				'woocommerce',
			)
		);

		add_theme_support( 'post-formats', array(
			'image',
			'video',
			'gallery',
			'audio', 
		) );

		add_theme_support(
			'custom-background',
			apply_filters(
				'wheel_alignment_service_custom_background_args',
				array(
					'default-color' => '101010',
					'default-image' => '',
				)
			)
		);

		add_theme_support( 'customize-selective-refresh-widgets' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 250,
				'width'       => 250,
				'flex-width'  => true,
				'flex-height' => true,
			)
		);

		add_theme_support( 'align-wide' );

		add_theme_support( 'responsive-embeds' );

		/*
		* This theme styles the visual editor to resemble the theme style,
		* specifically font, colors, icons, and column width.
		*/
		add_editor_style( '/resource/css/editor-style.css' );
	}
endif;
add_action( 'after_setup_theme', 'wheel_alignment_service_setup' );

function wheel_alignment_service_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'wheel_alignment_service_content_width', 640 );
}
add_action( 'after_setup_theme', 'wheel_alignment_service_content_width', 0 );

function wheel_alignment_service_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'wheel-alignment-service' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'wheel-alignment-service' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title"><span>',
			'after_title'   => '</span></h2>',
		)
	);

	// Regsiter 4 footer widgets.
	$wheel_alignment_service_footer_widget_column = get_theme_mod('wheel_alignment_service_footer_widget_column','4');
	for ($wheel_alignment_service_i=1; $wheel_alignment_service_i<=$wheel_alignment_service_footer_widget_column; $wheel_alignment_service_i++) {
		register_sidebar( array(
			'name' => __( 'Footer  ', 'wheel-alignment-service' )  . $wheel_alignment_service_i,
			'id' => 'wheel-alignment-service-footer-widget-' . $wheel_alignment_service_i,
			'description' => __( 'The Footer Widget Area', 'wheel-alignment-service' )  . $wheel_alignment_service_i,
			'before_widget' => '<aside id="%1$s" class="widget %2$s">',
			'after_widget' => '</aside>',
			'before_title' => '<div class="widget-header"><h4 class="widget-title">',
			'after_title' => '</h4></div>',
		) );
	}

	register_sidebar(
		array(
			'name'          => esc_html__( 'Header Sidebar', 'wheel-alignment-service' ),
			'id'            => 'sidebar-2',
			'description'   => esc_html__( 'Add widgets here.', 'wheel-alignment-service' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title"><span>',
			'after_title'   => '</span></h2>',
		)
	);
}
add_action( 'widgets_init', 'wheel_alignment_service_widgets_init' );

//Change number of products per page 
add_filter( 'loop_shop_per_page', 'wheel_alignment_service_products_per_page' );
function wheel_alignment_service_products_per_page( $cols ) {
  	return  get_theme_mod( 'wheel_alignment_service_products_per_page',9);
}

// Change number or products per row 
add_filter('loop_shop_columns', 'wheel_alignment_service_loop_columns');
	if (!function_exists('wheel_alignment_service_loop_columns')) {
	function wheel_alignment_service_loop_columns() {
		return get_theme_mod( 'wheel_alignment_service_products_per_row', 3 );
	}
}

/**
 * Enqueue scripts and styles.
 */
function wheel_alignment_service_scripts() {
	// Append .min if SCRIPT_DEBUG is false.
	$min = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';

	// Slick style.
	wp_enqueue_style( 'wheel-alignment-service-slick-style', get_template_directory_uri() . '/resource/css/slick' . $min . '.css', array(), '1.8.1' );

	// Fontawesome style.
	wp_enqueue_style( 'wheel-alignment-service-font-awesome-css', esc_url(get_template_directory_uri())."/resource/css/fontawesome-all.css" );

	// Main style.
	wp_enqueue_style( 'wheel-alignment-service-style', get_template_directory_uri() . '/style.css', array(), WHEEL_ALIGNMENT_SERVICE_VERSION );

	// RTL style.
	wp_style_add_data('wheel-alignment-service-style', 'rtl', 'replace');

	if (get_theme_mod('wheel_alignment_service_enable_animation', true) == true){
		// Animate CSS
		wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/resource/css/animate.css' );
		// Wow script.
		wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/resource/js/wow.js', array('jquery'),'' ,true );
	}
	
	// Navigation script.
	wp_enqueue_script( 'wheel-alignment-service-navigation-script', get_template_directory_uri() . '/resource/js/navigation.js', array(), WHEEL_ALIGNMENT_SERVICE_VERSION, true );

	// Slick script.
	wp_enqueue_script( 'wheel-alignment-service-slick-script', get_template_directory_uri() . '/resource/js/slick' . $min . '.js', array( 'jquery' ), '1.8.1', true );

	// Custom script.
	wp_enqueue_script( 'wheel-alignment-service-custom-script', get_template_directory_uri() . '/resource/js/custom.js', array( 'jquery' ), WHEEL_ALIGNMENT_SERVICE_VERSION, true );


	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}

	// Include the file.
	require_once get_theme_file_path( 'theme-library/function-files/wptt-webfont-loader.php' );

	// Load the webfont.
	wp_enqueue_style(
		'Oxanium',
		wheel_alignment_service_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Oxanium:wght@200..800&display=swap' ),
		array(),
		'1.0'
	);

	// Load the webfont.
	wp_enqueue_style(
		'Play',
		wheel_alignment_service_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Play:wght@400;700&display=swap' ),
		array(),
		'1.0'
	);

	// Load the webfont.
	wp_enqueue_style(
		'Bebas Neue',
		wheel_alignment_service_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Bebas+Neue&display=swap' ),
		array(),
		'1.0'
	);

}
add_action( 'wp_enqueue_scripts', 'wheel_alignment_service_scripts' );

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/theme-library/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/theme-library/function-files/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/theme-library/function-files/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/theme-library/customizer.php';

/**
 * Breadcrumb
 */
require get_template_directory() . '/theme-library/function-files/class-breadcrumb-trail.php';

/**
 * Google Fonts
 */
require get_template_directory() . '/theme-library/function-files/google-fonts.php';

/**
 * Dynamic CSS
 */
require get_template_directory() . '/theme-library/dynamic-css.php';

/**
 * Customizer Settings Functions
*/
require get_template_directory() . '/theme-library/function-files/customizer-settings-functions.php';

/**
 * Getting Started
*/
require get_template_directory() . '/theme-library/getting-started/getting-started.php';

function wheel_alignment_service_links_setup() {
	if ( ! defined( 'WHEEL_ALIGNMENT_SERVICE_PREMIUM_PAGE' ) ) {
	define('WHEEL_ALIGNMENT_SERVICE_PREMIUM_PAGE',__('https://asterthemes.com/products/alignment-services-wordpress-theme','wheel-alignment-service'));
	}
	if ( ! defined( 'WHEEL_ALIGNMENT_SERVICE_THEME_PAGE' ) ) {
		define('WHEEL_ALIGNMENT_SERVICE_THEME_PAGE',__('https://asterthemes.com/products/wheel-alignment-service','wheel-alignment-service'));
	}
	if ( ! defined( 'WHEEL_ALIGNMENT_SERVICE_SUPPORT' ) ) {
	define('WHEEL_ALIGNMENT_SERVICE_SUPPORT',__('https://wordpress.org/support/theme/wheel-alignment-service/','wheel-alignment-service'));
	}
	if ( ! defined( 'WHEEL_ALIGNMENT_SERVICE_REVIEW' ) ) {
	define('WHEEL_ALIGNMENT_SERVICE_REVIEW',__('https://wordpress.org/support/theme/wheel-alignment-service/reviews/','wheel-alignment-service'));
	}
	if ( ! defined( 'WHEEL_ALIGNMENT_SERVICE_PRO_DEMO' ) ) {
	define('WHEEL_ALIGNMENT_SERVICE_PRO_DEMO',__('https://demo.asterthemes.com/wheel-alignment-service/','wheel-alignment-service'));
	}
	if ( ! defined( 'WHEEL_ALIGNMENT_SERVICE_THEME_DOCUMENTATION' ) ) {
	define('WHEEL_ALIGNMENT_SERVICE_THEME_DOCUMENTATION',__('https://demo.asterthemes.com/docs/wheel-alignment-service-free/','wheel-alignment-service'));
	}
	if ( ! defined( 'WHEEL_ALIGNMENT_SERVICE_PREMIUM_DOCUMENTATION' ) ) {
	define('WHEEL_ALIGNMENT_SERVICE_PREMIUM_DOCUMENTATION',__('https://demo.asterthemes.com/docs/wheel-alignment-service-pro/','wheel-alignment-service'));
	}
	if ( ! defined( 'WHEEL_ALIGNMENT_SERVICE_BUNDLE_PAGE' ) ) {
		define('WHEEL_ALIGNMENT_SERVICE_BUNDLE_PAGE',__('https://asterthemes.com/products/wp-theme-bundle','wheel-alignment-service'));
	}
}
add_action('after_setup_theme', 'wheel_alignment_service_links_setup');

/**
 * Theme Wizard
*/
add_action( 'init', 'wheel_alignment_service_load_theme_wizard' );
function wheel_alignment_service_load_theme_wizard() {
    require get_parent_theme_file_path( '/theme-wizard/config.php' );
}

// Enqueue Customizer live preview script
function wheel_alignment_service_customizer_live_preview() {
    wp_enqueue_script(
        'wheel-alignment-service-customizer',
        get_template_directory_uri() . '/resource/js/customizer.js',
        array('jquery', 'customize-preview'),
        '',
        true
    );
}
add_action('customize_preview_init', 'wheel_alignment_service_customizer_live_preview');

// Featured Image Dimension
function wheel_alignment_service_blog_post_featured_image_dimension(){
	if(get_theme_mod('wheel_alignment_service_blog_post_featured_image_dimension') == 'custom' ) {
		return true;
	}
	return false;
}

// Reset all theme settings
function wheel_alignment_service_reset_demo_import_settings() {
    if (current_user_can('manage_options')) {
        // List only demo import-related settings to reset
		remove_theme_mod('wheel_alignment_service_enable_topbar');
		remove_theme_mod('wheel_alignment_service_welcome_topbar_text');
		remove_theme_mod('wheel_alignment_service_wishlist_button_link');
		remove_theme_mod('wheel_alignment_service_account_button_link');
		remove_theme_mod('wheel_alignment_service_enable_banner_section');
		remove_theme_mod('wheel_alignment_service_banner_heading');
		remove_theme_mod('wheel_alignment_service_banner_button_label_');
		remove_theme_mod('wheel_alignment_service_banner_button_link_');
		remove_theme_mod('wheel_alignment_service_banner_slider_category');
		remove_theme_mod('wheel_alignment_service_heading_services_section');
		remove_theme_mod('wheel_alignment_service_services_number');
		remove_theme_mod('wheel_alignment_service_enable_services_section');
		remove_theme_mod('wheel_alignment_service_services_text');

        wp_send_json_success(array('message' => __('Demo import settings have been reset.', 'wheel-alignment-service')));
    } else {
        wp_send_json_error(array('message' => __('Permission denied.', 'wheel-alignment-service')));
    }
}
add_action('wp_ajax_wheel_alignment_service_reset_demo_import_settings', 'wheel_alignment_service_reset_demo_import_settings'); 